#include "ant.h"

Ant new_ant(int x, int y, int vx, int vy, int raio){
   Ant ant = malloc(sizeof(struct st_ant));
   ant->x = x;
   ant->y = y;
   ant->vx = vx;
   ant->vy = vy;
   ant->raio = raio;
   return ant;
}

//A formiga precisa verificar bordas
void langton_ant(unsigned char ** new, unsigned char ** old, Ant ant){
   int k;
   int antx = ant->x;
   int anty = ant->y;
   int nivel;
   
   //rollback
   for (nivel =1; nivel <= ant->raio; nivel++){
      new[antx-nivel][anty-nivel] = old[antx-nivel][anty-nivel];
      new[antx-nivel][anty+0    ] = old[antx-nivel][anty+0    ];
      new[antx-nivel][anty+nivel] = old[antx-nivel][anty+nivel];
      new[antx+0    ][anty-nivel] = old[antx+0    ][anty-nivel];
      new[antx+0    ][anty+nivel] = old[antx+0    ][anty+nivel];
      new[antx+nivel][anty-nivel] = old[antx+nivel][anty-nivel];
      new[antx+nivel][anty+0    ] = old[antx+nivel][anty-nivel]; 
      new[antx+nivel][anty+nivel] = old[antx+nivel][anty+nivel];
   }
   if (new[antx+0    ][anty+0    ] < 127){
      //dead - black
      ant->vy *= -1; 
      SWAP(ant->vx,ant->vy,k);
   } else {
      //alive - white
      ant->vx *= -1;
      SWAP(ant->vx,ant->vy,k);
      new[antx][anty] = old[antx-1][anty-1] + old[antx-1][anty+0] + old[antx-1][anty+1] + old[antx+0][anty-1] +old[antx+0][anty+0] + old[antx+0][anty+1] + old[antx+1][anty-1] + old[antx+1][anty+0] + old[antx+1][anty+1]/8;
   }
   
   ant->x = ant->x + ant->vx;
   ant->y = ant->y + ant->vy;
   
}
