#include <stdio.h>
#include <stdlib.h>
#include <pam.h>
#include <pbm.h>
#include <pnm.h>


typedef struct st_map{
    int rows;
    int cols;
    int format;
    int antx;
    int anty;
    int vx;
    int vy;
    xel ** map;
    xelval maxval;
} * Map;

typedef xel colors;

Map new_map(char * name);
void close_pnm(Map m, FILE * pnm);
void info_pnm(Map m);
void save_pnm(Map m , char * name);
colors ** get_empty_slice(Map m, int rows, int cols, int border_size);
colors ** get_slice(Map m , int start_i, int start_j, int end_i, int end_j, int border_size );
void set_slice(Map m, int start_i, int start_j, int end_i, int end_j, int border_size, colors ** slice);
